""" SCRIPT CONFIGURATION PART """
messages = {
    10: '10 kills remaining',
    5: '5 kills remaining',
    1: '1 KILL REMAINING!',
    }

sounds = {
    10: 'killremain/killsremain 10.mp3',
    5: 'killremain/killsremain 5.mp3',
    1: 'killremain/killsremain 1.mp3',
    }
""" END OF CONFIGURATION PART """

import es
import playerlib

info = es.AddonInfo()
info.name = "Kills remaining"
info.basename = "kill_cd"
info.description = "Shows messages and optionally plays sounds when there are 10, 5 and 1 kill remaining in the round"

triggered = set()

fraglimit = es.ServerVar('mp_fraglimit')

def es_map_start(event_var):
    for sound in sounds.values():
        es.stringtable('downloadables', 'sound/'+sound)
    triggered.clear()

def round_start(event_var):
    triggered.clear()

def player_death(event_var):
    attacker = int(event_var['attacker'])
    if attacker and int(fraglimit):
        kills = int(playerlib.getPlayer(attacker).get('kills'))
        remaining = int(fraglimit) - kills
        if remaining not in triggered:
            if remaining in sounds:
                es.emitsound('player', attacker, sounds[remaining], 1.0, 0.0)
            if remaining in messages:
                centermessage(messages[remaining])
            triggered.add(remaining)

def centermessage(text):
    es.usermsg('create', 'KCDCMSG', 'TextMsg')
    es.usermsg('write', 'byte', 'KCDCMSG', 4)
    es.usermsg('write', 'string', 'KCDCMSG', text)
    for uid in es.getUseridList():
        es.usermsg('send', 'KCDCMSG', uid, 1)
    es.usermsg('delete', 'KCDCMSG')
